<?php

/**
 * @file
 * Contains \Drupal\otp_verification\Form\MiniorangeSettings.
 */

namespace Drupal\otp_verification\Form;
use Drupal\Core\Form\FormBase;
use Drupal\user\Entity\User;
use Drupal\otp_verification\MiniorangeOtpUtilities;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\otp_verification\MiniorangeOtpVerificationConstants;
use Drupal\Component\Utility\Unicode;


class MiniorangeValidateUser extends FormBase {
    public function getFormId() {
        return 'miniorange_otp_verification_validate_user';
    }

    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
    {

        // DO NOT DELETE
        /*
        if (session_status() == PHP_SESSION_NONE) {
            session_start();
        }*/
        global $user;
        global $form;
        global $form_state;

        $form = self::miniorange_otp_login_build_form($form, $form_state);
        return $form;
    }

    /**
    * Custom form build.
    */
    function miniorange_otp_login_build_form($form, &$form_state, $success_form = TRUE) {
        $submit_attributes = array();
        $form =  self::miniorange_otp_login_build_form_content($form, $form_state, $success_form);
        $form['loader']['#markup'] = '</div><div class="mo_otp-modal-mo_otp_container mo_otp-modal-footer">';
        // $query_parameters = $_GET;
        // if(isset($query_parameters ['otpto']))
        // {   \Drupal::messenger()->deleteAll();
        //     \Drupal::messenger()->addMessage(t('OTP has been sent to '.$query_parameters['otpto']),'status');
        //     //\Drupal::messenger()->addMessage(t('OTP has been sent to '.$_SESSION['trans_id']),'status');
        // }
        $form['actions']['submit'] = array(
            '#type' => 'submit',
            '#value' => 'Validate',
            '#submit' => array('::miniorange_otp_validation_user_validate'),
        );

        $form['actions']['resend'] = array(
            '#type' => 'submit',
            '#value' => t('Resend OTP'),
            '#attributes' => $submit_attributes,
            '#limit_validation_errors'=>array(),
            '#submit' => array('::miniorange_otp_resend_otp'),
        );
        $form['actions']['back'] = array(
            '#type' => 'submit',
            '#value' => t('Back'),
            '#attributes' => $submit_attributes,
            '#limit_validation_errors'=>array(),
            '#submit' => array('::miniorange_otp_back'),
        );
        return $form;
    }

    function miniorange_otp_login_build_form_content($form, $form_state, $success_form = TRUE) {
        return  self::miniorange_otp_login_build_otp_validation_form($form, $form_state, $success_form);
    }
    function miniorange_otp_back($form,$form_state){
        global $base_url;
        $response = new RedirectResponse($base_url . '/user/register');
        $response->send();
    }

    /**
    * Custom form build with error message.
    */
    function miniorange_otp_build_form_with_error_message(&$form_state) {
        echo "som3";exit;
        $form = array();
        $form =  self::miniorange_otp_build_form($form, $form_state, FALSE);
        $form_state['complete form']['header']['#markup'] = $form['header']['#markup'];
        return $form;
    }

    /**
    * Custom validation form build.
    */
    public function miniorange_otp_login_build_otp_validation_form($form, &$form_state, $success_message = TRUE) {
        $otp_options = \Drupal::config('otp_verification.settings')->get('miniorange_otp_options');
        if ($otp_options == 0) {
            $form['otp'] = array(
                '#name' => 'otp',
                '#type' => 'textfield',
                '#attributes' => array('autofocus' => 'autofocus',),
                '#title' => t('OTP'),
                '#default_value' => '',
                '#size' => 60,
                '#description' => t('Please enter the OTP that has been sent to the registered Email ID.'),
                '#maxlength' => 15,
                '#required'=>true,
            );
            return $form;
        }
        elseif ($otp_options == 1) {
            $form['otp'] = array(
                '#name' => 'otp',
                '#type' => 'textfield',
                '#attributes' => array('autofocus' => 'autofocus',),
                '#title' => t('OTP'),
                '#default_value' => '',
                '#size' => 60,
                '#description' => t('Please enter the OTP that has been sent to the registered Phone.'),
                '#maxlength' => 15,
                '#required'=>true,
            );
            return $form;
        }
    }

    /**
    * Resend OTP
    */
    function miniorange_otp_resend_otp(&$form, $form_state) {
        global $_miniorange_otp_x;
        $umail = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_email_val');
        $otp_options = \Drupal::config('otp_verification.settings')->get('miniorange_otp_options');
        // \Drupal::configFactory()->getEditable('otp_verification.settings')->clear('miniorange_otp_tx_id')->save();

        if ($otp_options == 0) {
            $emailcount = mb_strlen($umail);
            $emailc1 = mb_substr($umail, 0, 3);
            $emailc2 = mb_substr($umail, $emailcount - 4, $emailcount);
            for ($i = 4; $i <= $emailcount - 4; $i++) {
                $_miniorange_otp_x = "X" . $_miniorange_otp_x;
            }
            $email_code = $emailc1 . $_miniorange_otp_x . $emailc2;
            if (!MiniorangeOtpUtilities::isCurlInstalled()) {
                return json_encode(array(
                    "status" => 'CURL_ERROR',
                    "statusMessage" => '<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.',
                ));
            }
            $url = 'https://login.xecurify.com/moas/api/auth/challenge';
            $ch = curl_init($url);

            $api_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_api_key');
            $customer_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_id');

            // Current time in milliseconds since midnight, January 1, 1970 UTC.
            $current_time_in_millis = round(microtime(TRUE) * 1000);

            // Creating the Hash using SHA-512 algorithm.
            $string_to_hash = $customer_key . $current_time_in_millis . $api_key;
            $hash_value = hash("sha512", $string_to_hash);
            $customer_key_header = "Customer-Key: " . $customer_key;
            $timestamp_header = "Timestamp: " . $current_time_in_millis;
            $authorization_header = "Authorization: " . $hash_value;
            $fields = array(
                'customerKey' => $customer_key,
                'email' => $umail,
                'authType' => 'EMAIL',
                'transactionName' => 'Drupal OTP Verification',
            );

            $field_string = json_encode($fields);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_ENCODING, "");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                "Content-Type: application/json",
                $customer_key_header,
                $timestamp_header,
                $authorization_header,
            ));

            curl_setopt($ch, CURLOPT_POST, TRUE);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
            $content = curl_exec($ch);
            $trans_status = json_decode($content)->status;
            curl_close($ch);

            if ($trans_status == "SUCCESS") {
                $tx_id = json_decode($content)->txId;
                // \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_tx_id',$tx_id)->save();
                $_SESSION['trans_id'] = $tx_id;
                \Drupal::configFactory()->getEditable('miniorange_otp_current_status.settings')->set('miniorange_otp_verification_code','OTP_SENT')->save();

                \Drupal::messenger()->addMessage(t('OTP has been resent to @otp_resend', array('@otp_resend' => $email_code)),'status');
            }
            else {
                \Drupal::messenger()->addMessage(t('OTP could not be sent.'), 'error');
            }
        }
        else {
            $ph = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_phone_val');
            $phno = mb_strlen($ph);
            $phbr1 = mb_substr($ph, 0, 4);
            $phbr2 = mb_substr($ph, $phno - 2, $phno);
            for ($i = 5; $i <= $phno - 2; $i++) {
                $_miniorange_otp_x = "X" . $_miniorange_otp_x;
            }
            $ph_code = $phbr1 . $_miniorange_otp_x . $phbr2;
            if (!MiniorangeOtpUtilities::isCurlInstalled()) {
                return json_encode(array(
                    "status" => 'CURL_ERROR',
                    "statusMessage" => '<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.',
                ));
            }
            $url = 'https://login.xecurify.com/moas/api/auth/challenge';
            $ch = curl_init($url);
            $api_key =\Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_api_key');
            $customer_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_id');
            // Current time in milliseconds since midnight, January 1, 1970 UTC.
            $current_time_in_millis = round(microtime(TRUE) * 1000);
            // Creating the Hash using SHA-512 algorithm.
            $string_to_hash = $customer_key . $current_time_in_millis . $api_key;
            $hash_value = hash("sha512", $string_to_hash);
            $customer_key_header = "Customer-Key: " . $customer_key;
            $timestamp_header = "Timestamp: " . $current_time_in_millis;
            $authorization_header = "Authorization: " . $hash_value;

            $fields = array(
                'customerKey' => $customer_key,
                'phone' => $ph,
                'authType' => 'SMS',
                'transactionName' => 'Drupal OTP Verification',
            );

            $field_string = json_encode($fields);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_ENCODING, "");
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customer_key_header, $timestamp_header, $authorization_header,));
            curl_setopt($ch, CURLOPT_POST, TRUE);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);

            $content = curl_exec($ch);
            $trans_status = json_decode($content)->status;
            curl_close($ch);
            if ($trans_status == "SUCCESS") {
                $tx_id = json_decode($content)->txId;
                // \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_tx_id',$tx_id)->save();
                $_SESSION['trans_id'] = $tx_id;
                \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_current_status','OTP_SENT')->save();

                \Drupal::messenger()->addMessage(t('OTP has been resent to @otp_resend_phone', array('@otp_resend_phone' => $ph_code)),'status');
            }
            else {
                \Drupal::messenger()->addMessage(t('OTP could not be sent.'), 'error');
            }
        }
    }

    /**
    * Handling and validating user.
    */
    public function miniorange_otp_validation_user_validate($form, &$form_state) {
        $uname = isset($_SESSION['miniorange_otp']['register_values']['name'])?$_SESSION['miniorange_otp']['register_values']['name']:'';
        $otp_options = \Drupal::config('otp_verification.settings')->get('miniorange_otp_options');
        $mail = isset($_SESSION['miniorange_otp']['register_values']['mail'])?$_SESSION['miniorange_otp']['register_values']['mail']:'';
        $pwd = isset($_SESSION['miniorange_otp']['register_values']['pass'])? $_SESSION['miniorange_otp']['register_values']['pass'] : '' ;
        $otp_token = $form_state->getValue('otp');
        $otp_token = trim($otp_token);
        //$trans_id = \Drupal::config('otp_verification.settings')->get('miniorange_otp_tx_id');
        $trans_id = $_SESSION['trans_id'];

        if (!MiniorangeOtpUtilities::isCurlInstalled()) {
            return json_encode(array(
                "status" => 'CURL_ERROR',
                "statusMessage" => '<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.',
            ));
        }

        $url = 'https://login.xecurify.com/moas/api/auth/validate';
        $ch = curl_init($url);
        global $base_url;
        $customer_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_id');
        $api_key = \Drupal::config('otp_verification.settings')->get('miniorange_otp_verification_customer_api_key');
        $current_time_in_millis = round(microtime(TRUE) * 1000);
        $string_to_hash = $customer_key . $current_time_in_millis . $api_key;
        $hash_value = hash("sha512", $string_to_hash);
        $customer_key_header = "Customer-Key: " . $customer_key;
        $timestamp_header = "Timestamp: " . $current_time_in_millis;
        $authorization_header = "Authorization: " . $hash_value;
        if ($otp_options == 1) {
            $fields = array(
                'txId' => $trans_id,
                'token' => $otp_token,
                'customerKey' => $customer_key,
                'username' => $mail,
                'authType' => 'PHONE',
            );
        }
        else {
            $fields = array(
                'txId' => $trans_id,
                'token' => $otp_token,
                'customerKey' => $customer_key,
                'username' => $mail,
                'authType' => 'EMAIL',
            );
        }

        $field_string = json_encode($fields);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        curl_setopt($ch, CURLOPT_ENCODING, "");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customer_key_header, $timestamp_header, $authorization_header,));
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $field_string);
        $content = curl_exec($ch);
        curl_close($ch);
        \Drupal::configFactory()->getEditable('otp_verification.settings')->set('miniorange_otp_token',$otp_token)->save();
        $otp_status = json_decode($content)->status;
        $phone_number = \Drupal::config('otp_verification.settings')->get('phone_number_register');
        \Drupal::messenger()->deleteAll();
        if ($otp_status == "SUCCESS") {
            //$arr1 = \Drupal::config('otp_verification.settings')->get('arr1');
            //$arr2 = \Drupal::config('otp_verification.settings')->get('arr2');
            $arr2 = $_SESSION['arr2'];
            $default_role = "authenticated user";
            unset($_SESSION['miniorange_otp']);
            //user_register_submit($arr1,$arr2);
            $random_password = user_password(8);
            $machine_name_of_phone_field=\Drupal::config('otp_verification.settings')->get('machine_name_of_phone_field');
            $new_user = array(
              'name' => $arr2['name'],
              'mail' => $arr2['mail'],
              'pass' => $arr2['pass'],
              'status' => 1,
              'roles' =>  $default_role,
              $machine_name_of_phone_field => $phone_number,
            );
            $account = User::create($new_user);
            $account -> save();
            $edit['redirect'] = $base_url;
            user_login_finalize($account);
            \Drupal::messenger()->addMessage(t('Registration successful. Now you are logged in.'), 'status');
            $response = new RedirectResponse($edit['redirect']);
            $response->send();
            //drupal_goto('<front>');
        }
        elseif ($otp_status == "FAILED") {
            \Drupal::messenger()->addMessage(t('OTP entered is incorrect.'), 'error');
        }
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

    }
}
